// CodeGear C++Builder
// Copyright (c) 1995, 2011 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'LogError.pas' rev: 23.00 (Win32)

#ifndef LogerrorHPP
#define LogerrorHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <Winapi.Windows.hpp>	// Pascal unit
#include <Winapi.Messages.hpp>	// Pascal unit
#include <System.Classes.hpp>	// Pascal unit
#include <Vcl.Graphics.hpp>	// Pascal unit
#include <System.SysUtils.hpp>	// Pascal unit
#include <Vcl.Controls.hpp>	// Pascal unit
#include <Vcl.Forms.hpp>	// Pascal unit
#include <Vcl.Dialogs.hpp>	// Pascal unit
#include <LogBase.hpp>	// Pascal unit
#include <SMMapFile.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Logerror
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TSMLAOption : unsigned char { laShowSendEMail, laShowSupportLink, laShowSourceLine };
#pragma option pop

typedef System::Set<TSMLAOption, TSMLAOption::laShowSendEMail, TSMLAOption::laShowSourceLine>  TSMLAOptions;

#pragma option push -b-
enum TSMLErrorDialog : unsigned char { edNone, edStandard, edExtended };
#pragma option pop

#pragma option push -b-
enum TSMLFormat : unsigned char { lfDate, lfTime, lfPhysAddress, lfExceptionClassName, lfMessage, lfSeparator, lfSourceLine, lfApplication, lfActiveControl, lfComputerInfo, lfOSInfo, lfCPUInfo, lfMemoryInfo, lfVideoCard };
#pragma option pop

typedef System::Set<TSMLFormat, TSMLFormat::lfDate, TSMLFormat::lfVideoCard>  TSMLFormats;

#pragma option push -b-
enum TSMExceptionStandard : unsigned char { efAbort, efOutOfMemory, efInOutError, efIntError, efDivByZero, efRangeError, efIntOverflow, efMathError, efInvalidOp, efZeroDivide, efOverflow, efUnderflow, efInvalidPointer, efInvalidCast, efConvertError, efAccessViolation, efPrivilege, efStackOverflow, efControlC, efVariantError, efPropReadOnly, efPropWriteOnly, efExternalException, efAssertionFailed, efAbstractError, efIntfCastError, efInvalidContainer, efInvalidInsert, efPackageError, efWin32Error };
#pragma option pop

typedef System::Set<TSMExceptionStandard, TSMExceptionStandard::efAbort, TSMExceptionStandard::efWin32Error>  TSMExceptionStandards;

#pragma option push -b-
enum TSMExceptionClass : unsigned char { efStreamError, efFCreateError, efFOpenError, efFilerError, efReadError, efWriteError, efClassNotFound, efMethodNotFound, efInvalidImage, efResNotFound, efListError, efBitsError, efStringListError, efComponentError, efParserError, efOutOfResources, efInvalidOperation, efThread };
#pragma option pop

typedef System::Set<TSMExceptionClass, TSMExceptionClass::efStreamError, TSMExceptionClass::efThread>  TSMExceptionClasses;

#pragma option push -b-
enum TSMExceptionGraphic : unsigned char { efInvalidGraphic, efInvalidGraphicOperation };
#pragma option pop

typedef System::Set<TSMExceptionGraphic, TSMExceptionGraphic::efInvalidGraphic, TSMExceptionGraphic::efInvalidGraphicOperation>  TSMExceptionGraphics;

typedef void __fastcall (__closure *TSMLSaveExceptionEvent)(System::TObject* Sender, System::Sysutils::Exception* E, System::UnicodeString &LogText, bool &Accept);

class DELPHICLASS TSMExceptionLog;
class PASCALIMPLEMENTATION TSMExceptionLog : public Logbase::TSMLogBase
{
	typedef Logbase::TSMLogBase inherited;
	
private:
	bool InternalProcessing;
	Vcl::Forms::TExceptionEvent FoldOnException;
	Vcl::Forms::TExceptionEvent FOnException;
	TSMLSaveExceptionEvent FOnSaveException;
	TSMLErrorDialog FErrorDialog;
	TSMExceptionStandards FFilterStandard;
	TSMExceptionClasses FFilterClasses;
	TSMExceptionGraphics FFilterGraphics;
	TSMLFormats FFormats;
	TSMLAOptions FOptions;
	Smmapfile::TSMMapFile* FMapFile;
	void __fastcall ActiveWeb(System::TObject* Sender);
	void __fastcall ActivateMail(System::TObject* Sender, bool IncludeScreenshot);
	
protected:
	void __fastcall DoException(System::TObject* Sender, System::Sysutils::Exception* E);
	
public:
	__fastcall virtual TSMExceptionLog(System::Classes::TComponent* AOwner);
	__fastcall virtual ~TSMExceptionLog(void);
	System::UnicodeString __fastcall GetFormattedSource(void);
	System::UnicodeString __fastcall GetApplicationDetails(void);
	System::UnicodeString __fastcall GetActiveControlDetails(void);
	System::UnicodeString __fastcall GetComputerInfo(void);
	System::UnicodeString __fastcall GetMemoryInfo(void);
	System::UnicodeString __fastcall GetOSInfo(void);
	System::UnicodeString __fastcall GetCPUInfo(bool IncludeSpeed);
	System::UnicodeString __fastcall GetVideoCardInfo(void);
	__property Smmapfile::TSMMapFile* MapFile = {read=FMapFile, write=FMapFile};
	
__published:
	__property TSMLErrorDialog ErrorDialog = {read=FErrorDialog, write=FErrorDialog, default=2};
	__property TSMExceptionStandards FilterStandard = {read=FFilterStandard, write=FFilterStandard, default=1073741823};
	__property TSMExceptionClasses FilterClasses = {read=FFilterClasses, write=FFilterClasses, default=262143};
	__property TSMExceptionGraphics FilterGraphics = {read=FFilterGraphics, write=FFilterGraphics, default=3};
	__property TSMLFormats Formats = {read=FFormats, write=FFormats, default=951};
	__property TSMLAOptions Options = {read=FOptions, write=FOptions, default=3};
	__property Vcl::Forms::TExceptionEvent OnException = {read=FOnException, write=FOnException};
	__property TSMLSaveExceptionEvent OnSaveException = {read=FOnSaveException, write=FOnSaveException};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Logerror */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_LOGERROR)
using namespace Logerror;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// LogerrorHPP
